/* ------------------------------------------------------- */
/*     заголовочный файл обработчика энкодера encod.h      */
/*-------------------------------------------------------- */
#ifndef _encod_H        // Блокируем повторное включение этого модуля
#define _encod_H
//------------------------------------------------------------------------
// обязательная "магическая добавка" (начало)
#if ARDUINO >= 100
 #include "Arduino.h"
#else
 #include "WProgram.h"
#endif
// обязательная "магическая добавка" (конец)
//------------------------------------------------------------------------
 #include <avr/interrupt.h> // обслуживание прерываний
//------------------------------------------------------------------------

// тип данных - указатель на функцию текущего селектора обработки
typedef void(*Fn0Ptr)(byte);

// линия ввода данных Х
extern const byte P_enc;
// линия ввода данных D
extern const byte D_enc;

// порт, используемый для ввода данных
// предпочтительно порт D т.к. нумерация цифровых выводов
// ардуино-нано /про-мини совпадает с нумерацией
// соответствующих бит порта (или порт С)
#define PortEnc PIND

// значение счетчика интервала между опросами
// линий энкодера в микросекундах
extern const byte enc_wait;

// флаг вспомогательного генератора таймер-меток
extern volatile byte QtTm;

// флаг запроса очередной обработки данных энкодера
// (содержимого счетчика enc_cnt)
extern volatile byte QtEnc;

// основной счетчик энкодера
extern volatile int enc_cnt;

//------------------------------------------------------------------------
// инициалзация выводов МК и генератора сетки опроса сигнальных линий
extern void enc_init();

// функция определения направления
void enc_start(byte);

// функция первой ступени P
void enc_P1(byte);

// функция первой ступени D
void enc_D1(byte);

// функция второй ступени P
void enc_P2(byte);

// функция второй ступени D
void enc_D2(byte);

// функция третьей ступени P
void enc_P3(byte);

// функция третьей ступени D
void enc_D3(byte);


//------------------------------------------------------------------------

#endif      // Закрывающий #endif к блокировке повторного включения

//-------------конец файла/end of file---------------------
